clear all
set more off
cd ""
import excel using "classification.xlsx", clear firstrow
drop id
ren idCoarse id
save classification, replace

import delim using "Sic-IO1992.txt", delim("|") clear 
gen ioind = substr(v1, 1, 7)
gen description = substr(v1, 8,34)
gen sic = substr(v1, 42, .)
drop v1
drop in 1/11
drop in 861/887
gen test1=(substr(ioind, 7, 1)==" ")
gen test2=(substr(ioind, 1, 1)!=" ")
replace ioind="0"+ioind if test1==1 & test2==1
replace ioind=strtrim(ioind)
drop test*
gen test1 = (ioind=="")
gen test2 = (description=="                                  ")
replace test1 = 2 if test1[_n-1]==1 & test1==1
replace description = description[_n-1]+description if test1==1 & test2==0
replace ioind = ioind[_n-1] if test1==1 & test2==0
replace description = description[_n-1]+description if test1==2 & test2==0
replace ioind = ioind[_n-1] if test1==2 & test2==0
replace sic = sic[_n-1]+sic if test1>0 & test2==1
replace description = description[_n-1] if test1>0 & test2==1
replace ioind = ioind[_n-1] if test1>0 & test2==1
replace sic = strtrim(sic)
replace sic = stritrim(sic)
drop if sic==""
drop if substr(ioind,3,1)!="."
gen x = length(sic)
bys ioind: egen max_length = max(x)
drop if x<max_length
replace description = strtrim(description)
replace description = stritrim(description)
drop test1-max_length
compress
gen first=substr(ioind,1,2)
gen second =substr(ioind,4,4)
replace ioind=first+second
drop description first second
save IO_sic1992, replace


forvalues year = 1982(10)1992 {
import delim using "io-code`year'.txt", delim(";") clear
keep v1 v2
tostring v1, replace
replace v1 = "0"+v1 if length(v1)<6
rename v1 ioind 
rename v2 desc`year'
save io_desc`year', replace
}


forvalues year = 1972(5)1982 {
if `year'==1972 {
	local ext "txt"
	local del " "
	local corr "correspondence_ioind_sic72.dta"
	}
if `year'==1977 {
	local ext "csv"
	local del ","
	local corr "correspondence_ioind_sic7782.dta"
	}
if `year'==1982 {
	local ext "csv"
	local del ","
	local corr "correspondence_ioind_sic7782.dta"
	}
import delim using `year'UseMake.`ext', delim("`del'") clear
foreach var of varlist v1 v2 {
	capture tostring `var', replace
	replace `var' = strtrim(`var')
	replace `var' = "0"+`var' if length(`var')<6
}
keep v1 v2
gen x=_n
reshape long v, i(x) j(y)
drop x y
sort v
by v: gen z = _n
keep if z == 1
drop z
rename v ioind
merge 1:1 ioind using `corr'
gen appear`year' = 1 if _merge == 1 | _merge == 3
drop _merge
save code`year', replace
}

forvalues year = 1987(5)1992 {
if `year'==1987 {
	local ext "csv"
	local del ","
	}
if `year'==1992 {
	local ext "txt"
	local del " "
	}

import delim using `year'Use.`ext', delim("`del'") clear
foreach var of varlist v1 v2 {
	capture tostring `var', replace
	replace `var' = strtrim(`var')
	replace `var' = "0"+`var' if length(`var')<6
}
keep v1 v2
gen x=_n
reshape long v, i(x) j(y)
drop x y
sort v
by v: gen z = _n
keep if z == 1
drop z
rename v ioind
merge 1:1 ioind using correspondence_ioind_sic.dta
gen appear`year' = 1 if _merge==1 | _merge==3
drop _merge
save temp, replace

import delim using `year'Make.`ext', delim("`del'") clear
foreach var of varlist v1 v2 {
	capture tostring `var', replace
	replace `var' = strtrim(`var')
	replace `var' = strrtrim(`var')
	replace `var' = "0"+`var' if length(`var')<6
}
keep v1 v2
gen x=_n
reshape long v, i(x) j(y)
drop x y
sort v
by v: gen z = _n
keep if z == 1
drop z
rename v ioind
merge 1:1 ioind using correspondence_ioind_sic.dta
gen appear`year' = 1 if _merge==1 | _merge==3
drop _merge
append using temp
bys ioind: gen z=_n
keep if z==1
drop z
if `year'==1992 {
	merge n:1 ioind using IO_sic1992
	drop _merge
	}	
save code`year', replace
}

use code1972, clear
forvalues year=1977(5)1992 {
merge 1:1 ioind naics using code`year'
drop _merge
}
bys ioind: gen test2=_n
bys ioind: egen max=max(test)
gen test = "error" if max>1
gen test3 = min(appear1972, appear1977, appear1982, appear1987, appear1992)
replace test = "error" if test3 ==.
drop max test2 test3
merge n:1 ioind using io_desc1982
drop _merge
merge n:1 ioind using io_desc1992
drop _merge
replace desc1982 = strtrim(desc1982)
replace desc1992 = strtrim(desc1992)
compress
replace desc1982=desc1992+"(1992)" if desc1982=="" & desc1992!=""
rename desc1982 description
drop desc1992
replace description = "S&L gov"+substr(description,27,.) if substr(description,1,26)=="State and local government"
gen pos=strpos(description,"consumption expenditures")
replace description = substr(description, 1, pos-1)+"C"+substr(description,pos+24,.) if pos>0
replace pos=strpos(description,"gross investment")
replace description = substr(description, 1, pos-1)+"I"+substr(description,pos+16,.) if pos>0
replace pos=strpos(description,"consumption expenditures(1992)")
replace description = substr(description,1,pos-1)+"(1992)" if pos>0
replace pos=strpos(description,"gross investment(1992)")
replace description = substr(description,1,pos-1)+"(1992)" if pos>0
order ioind naics test sic description

*Substitution- 1 unused code
drop if ioind=="120217" | ioind=="130400" | ioind=="140201" | ioind=="140203"
drop if ioind=="730304" | ioind=="730305"
*Substitution- 2 200903(sic 2499) assigned to 3219, 3212. should be 3219
replace naics="3219" if ioind=="200903"
replace sic="2499" if ioind=="200903"
*Substitution- 3 320400(sic 308) assigned to 3261 & 3262. Should be 3261
replace naics="3261" if ioind=="320400"
replace sic="308" if ioind=="320400"
*Substitution- 4 580400(sic 3694) assigned to 3341 & 3353. Should be 3363
replace naics="3363" if ioind=="580400"
replace sic="3694" if ioind=="580400"
*Substitution- 5 610602(sic 2451, 1992 IO-code 200703) assigned to 3362/3219. Should be 3219
replace naics="3219" if ioind=="610602"
replace sic="2451" if ioind=="610602"
*Substitution- 6 620700(sic 387) assigned to 3345/339. Should be 3345
replace naics="3345" if ioind=="620700"
replace sic="387" if ioind=="620700"
*Substitution- 7 630300(sic 386) assigned to 339/3333,9. Should be 3333,9
replace naics="3333,9" if ioind=="630300"
replace sic="386" if ioind=="630300"
*Substitution- 8 650702(sic 472) assigned to 48,9/512-4. Should be PROF
replace naics="532, 533, 54, 55, 56" if ioind=="650702"
replace sic="472" if ioind=="650702"
*Substitution- 9 670000(sic 483) assigned to 512-4/2211. Should be 5111
replace naics="5111" if ioind=="670000"
replace sic="483" if ioind=="670000"
*Substitution- 10 680100(sic 491, 4931) assigned to 2212/2211. Should be 2211
replace naics="2211" if ioind=="680100"
replace sic="491, 4931" if ioind=="680100"
*Substitution- 11 780100(sic 43) assigned to 54/G. Should be G
replace naics="491, S001, S002, S005, S006, S007" if ioind=="780100"
replace sic="43" if ioind=="780100"
*Substitution- 12 780200(federal electricity) assigned to 54/G. Should be G
replace naics="491, S001, S002, S005, S006, S007" if ioind=="780200"
replace sic="" if ioind=="780200"

collapse (min) appear1972-appear1992, by(ioind naics sic description)
drop in 1/1

*Now apply the new classification
replace naics="3116, 3117" if naics=="3116"
replace naics="3372, 3379" if naics=="3372,9"
replace naics="3311, 3312" if naics=="3311,2"
replace naics="3329, 3324" if naics=="3329"
replace naics="3333, 3339" if naics=="3333,9"
replace naics="3341, 3346" if naics=="3341"

replace naics="211, 213" if naics=="211" | naics=="213"
replace naics="11" if naics=="nonip11"
replace naics="23" if naics=="nonip23"
replace naics="48, 492-3, 2213" if substr(ioind,1,2)=="65" & ioind!="650702"
replace naics="5112, 512-9" if substr(ioind,1,2)=="66"
replace naics="48, 492-3, 2213" if substr(ioind,1,4)=="6803"
replace naics="42" if ioind=="690100"
replace naics="44, 45, 4A" if ioind=="690200"
replace naics="52, 531, S008" if naics=="nonip52"
replace naics="721" if substr(ioind,1,4)=="7201"
replace naics="81" if substr(ioind,1,4)=="7202"|substr(ioind,1,4)=="7203"
replace naics="81" if ioind=="730101"
replace naics="532, 533, 54, 55, 56" if substr(ioind,1,2)=="73" & ioind!="730101"
replace naics="722" if substr(ioind,1,2)=="74"
replace naics="532, 533, 54, 55, 56" if ioind=="750001"
replace naics="81" if substr(ioind,1,2)=="75" & ioind!="750001"
replace naics="5112, 512-9" if ioind=="760101" | ioind=="760100"
replace naics="532, 533, 54, 55, 56" if ioind=="760102"
replace naics="711-3" if substr(ioind,1,4)=="7602"
replace naics="62" if substr(ioind,1,4)=="7701" | substr(ioind,1,4)=="7702" |/*
	*/substr(ioind,1,4)=="7703"
replace naics="61" if substr(ioind,1,4)=="7704"
replace naics="81" if substr(ioind,1,4)=="7705"
replace naics="62" if substr(ioind,1,4)=="7706" | substr(ioind,1,4)=="7707" |/*
	*/substr(ioind,1,4)=="7708" | substr(ioind,1,4)=="7709"
replace naics="491, S001, S002, S005, S006, S007" if naics=="nonipG"

replace naics="S003" if ioind=="800000"
replace naics="S004" if substr(ioind,1,2)=="81"
replace naics="S009" if substr(ioind,1,2)=="83"
replace naics="F01000" if substr(ioind,1,2)=="91"
replace naics="F02000" if substr(ioind,1,2)=="92" | substr(ioind,1,2)=="93"
replace naics="F04000" if substr(ioind,1,2)=="94"
replace naics="F05000" if substr(ioind,1,2)=="95"
/*Here below the change in naics code is for the pursose of merging with classification
They don't correspond to the exact meaning of this naics code*/ 
replace naics="F06I00" if substr(ioind,-2,1)=="I"
replace naics="F06C00" if substr(ioind,-2,1)=="C"
replace naics="F06I00" in 686/691
replace naics="F00000" if substr(ioind,1,1)=="9" & naics==""
replace naics="S009" if ioind=="850000" | ioind=="840000" 
replace sic="" in 1/23 
replace sic="" if naics=="23" 
replace sic="4923-5, 4932, 4939" if ioind=="680202"
replace sic="732; 7331,4,8; 7383,9" if ioind=="730109"
replace sic="8042-3,9; 807; 809" if ioind=="770305"
replace sic="791; 7992-3,6,9" if ioind=="760206"
replace sic="84; 865, 9; 8733; 6732" if ioind=="770504"
compress

merge n:1 naics using classification
order ioind id sic shortname description appear*
drop if _merge==2
sort ioind
drop _merge naics FRBcode
compress

export excel using corr1972-1992.xlsx, replace firstrow(variable)
