clear all
set more off
cd ""

import excel using "classification.xlsx", firstrow clear

drop id
ren idCoarse id

drop FRBcode description
gen z=strpos(naics, ",")
sum z
local max=r(max)
while `max'>0 {
expand 2 if z>0
bys naics: gen rank=_n if z>0
replace naics=substr(naics, 1, z-1) if rank==1 
replace naics=substr(naics, z+1,.) if rank==2
drop rank
replace z=strpos(naics, ",")
sum z
local max = r(max)
}
replace z = strpos(naics, "-")
gen before=substr(naics,z-1,1) if z>0
gen after=substr(naics,z+1,1) if z>0
destring after before, replace
expand =after-before+1 if z>0
bys naics: gen rank=_n if z>0
gen last_digit=before+rank-1
tostring last_digit, replace
replace naics=substr(naics,1,z-2)+last_digit if z>0
drop in 1/1
drop z-last_digit
sort id
replace naics=strtrim(naics)
compress
save classification, replace
local CLSN=_N

import excel using flow1997, sheet("Ind123") cellrange(B3:D125) clear
rename B code
rename C desc
rename D naics
replace code = strtrim(code)
replace naics= strtrim(naics)
replace desc = strtrim(desc)
gen z = strpos(naics,",")
summarize z
local max=r(max)
while `max'>0 {
	expand 2 if z>0
	sort naics
	by naics: gen rank=_n if z>0
	replace naics = substr(naics,1,z-1) if rank==1
	replace naics = substr(naics,z+1,.) if rank==2
	drop rank
	replace z = strpos(naics,",")
	summarize z
	local max=r(max)
}
replace z = strpos(naics, "*")
replace naics = substr(naics, 1, z-1) if z>0
replace z = strpos(naics,"-")
gen before = substr(naics,z-1,1) if z>0
gen after = substr(naics,z+1,1) if z>0
destring before after, replace force
expand after-before+1 if z>0
sort naics
by naics: gen last_digit= before + _n -1 if z>0
tostring last_digit, replace
replace naics = substr(naics,1,z-2)+last_digit if z>0
replace naics = strtrim(naics)
compress
keep code desc naics
gen group = "industry"
rename naics naics2
merge 1:1 _n using classification
drop _merge
gen length=length(naics) if naics!=""
gen G=.
gen H=""
forvalues x=1/`CLSN' {
local naics=naics[`x']
local id=id[`x']
local shortname=shortname[`x']
local length=length[`x']
replace G=`id' if substr(naics2,1,`length')=="`naics'"
replace H="`shortname'" if substr(naics2,1,`length')=="`naics'"
}
drop naics-length
rename naics2 naics
rename G id
rename H short_name
sort code id
by code id: gen rank=_n
keep if rank==1
drop naics
by code: replace rank=_n
by code: gen label="error" if _N>1
by code: keep if rank==_N
replace rank =. if rank==1
	/* Some industries correspond to more than one id code. Keep one for now.
	  We make the necc. adjustment later in read_ip*/
save temp, replace

*** The commodity code ***

import excel using flow1997, sheet("Comm180") cellrange(A2:I92) clear
drop A E F
rename B code1
rename C desc1
rename D naics1
rename G code2
rename H desc2
rename I naics2
drop in 1/1
gen rank=_n
reshape long code naics desc, i(rank) j(x)
drop rank x
replace desc = strtrim(desc)
replace code = strtrim(code)
replace naics= strtrim(naics)
gen z = strpos(naics,",")
summarize z
local max=r(max)
while `max'>0 {
	expand 2 if z>0
	sort naics
	by naics: gen rank=_n if z>0
	replace naics = substr(naics,1,z-1) if rank==1
	replace naics = substr(naics,z+1,.) if rank==2
	drop rank
	replace z = strpos(naics,",")
	summarize z
	local max=r(max)
}
replace z = strpos(code, "*")
replace code = substr(code, 1, z-1) if z>0
replace z = strpos(naics, "*")
replace naics = substr(naics, 1, z-1) if z>0
replace code = strtrim(code)
replace naics= strtrim(naics)
replace naics = "S003" if code=="S00300"
compress
rename naics naics2
gen G=.
gen H=""
merge 1:1 _n using classification
drop _merge
gen length=length(naics) if naics!=""
forvalues x=1/`CLSN' {  /* the number 165 = _N in classification*/
local naics=naics[`x']
local id=id[`x']
local shortname=shortname[`x']
local length=length[`x']
replace G=`id' if substr(naics2,1,`length')=="`naics'"
replace H="`shortname'" if substr(naics2,1,`length')=="`naics'"
}
drop naics-length
rename naics2 naics
rename G id
rename H short_name
drop z
gen group = "commodity"
bys code id: gen rank=_n
keep if rank==1
drop naics rank

append using temp

export excel using corrCapital.xlsx, firstrow(variable) replace
